## hopman 1.14

=== Makefile ===
#     Copyright (C) 2019 Didier Kryn <kryn@in2p3.fr> -- See LICENSE
# 'make'           build the executable
# 'make clean'     remove object files, keep libraries and executable
# 'make install'   install executable, etc. -- listed in  $(INSTALLED_FILES)
# 'make cleanall'  remove everything but source files and installed files
# 'make uninstall' remove installed files
# You must be root to make install/uninstall
#
#
#  In this makefile we rely on makefiles in other directories and we need
# to know their dependencies. These other makefiles provide targets to
# print their dependencies


GUI_DIR   := GTK
WATCH_DIR := watch
ANNEX_DIR := annex
ICON_DIR  := icon

VPATH := $(GUI_DIR):$(WATCH_DIR):$(ANNEX_DIR)

# Get list of dependencies from sub-makefiles
GUI_DEPS   := $(shell $(MAKE) -s -r -C $(GUI_DIR)   print_deps)
WATCH_DEPS := $(shell $(MAKE) -s -r -C $(WATCH_DIR) print_deps)
ANNEX_DEPS := $(shell $(MAKE) -s -r -C $(ANNEX_DIR) print_deps)

INSTALLED_FILES = /usr/bin/hopman-$(GUI_DIR) /usr/bin/hopman \
/usr/share/man/man8/hopman.8.gz /usr/share/man/man8/hopmanrc.8.gz \
/etc/default/hopmanrc /usr/share/pixmaps/hopman.png \
/usr/share/applications/hopman.desktop /usr/share/doc/hopman/copyright

.SUFFIXES:

all: $(GUI_DIR)/hopman

#--------- Executable
$(GUI_DIR)/hopman: $(GUI_DEPS)
	@$(MAKE) -r -C $(GUI_DIR) hopman

$(WATCH_DIR)/watch.a: $(WATCH_DEPS)
	@$(MAKE) -r -C $(WATCH_DIR) watch.a

$(ANNEX_DIR)/annex.a: $(ANNEX_DEPS)
	@$(MAKE) -r -C $(ANNEX_DIR) annex.a

#--------- Installation
# Essentials:
install: $(INSTALLED_FILES)

/usr/bin/hopman: /usr/bin/hopman-$(GUI_DIR)
	(cd /usr/bin; ln -sf hopman-$(GUI_DIR) hopman)

/usr/bin/hopman-$(GUI_DIR): $(GUI_DIR)/hopman
	cp $< $@

/usr/share/man/man8/hopman.8.gz: doc/man/man8/hopman
	gzip -c  $<   > $@

/usr/share/man/man8/hopmanrc.8.gz: doc/man/man8/hopmanrc
	gzip -c  $<   > $@

/etc/default/hopmanrc: $(ANNEX_DIR)/hopmanrc
	cp  $<  $@

/usr/share/pixmaps/hopman.png: $(ICON_DIR)/removable-media-32x32.png
	cp $<  $@

/usr/share/applications/hopman.desktop: hopman.desktop
	cp $<  $@

/usr/share/doc/hopman/copyright: LICENSE /usr/share/doc/hopman
	cp $<  $@

/usr/share/doc/hopman:
	mkdir $@

#------- Cleaning
clean:
	$(MAKE) -r -C $(WATCH_DIR) clean
	$(MAKE) -r -C $(ANNEX_DIR) clean
	$(MAKE) -r -C $(GUI_DIR) clean
	rm -vf $(wildcard doc/man/man8/*~)
	rm -vf $(wildcard *~)

cleanall:
	$(MAKE) -r -C $(WATCH_DIR) cleanall
	$(MAKE) -r -C $(ANNEX_DIR) cleanall
	$(MAKE) -r -C $(GUI_DIR)   cleanall
	rm -vf $(wildcard doc/man/man8/*~)
	rm -vf $(wildcard *~)

uninstall:
	rm -vf $(INSTALLED_FILES)
	rm -rvf /usr/share/doc/hopman

.PHONY: clean cleanall uninstall print_all_deps
.SILENT: clean cleanall uninstall print_all_deps

#-------- Utilities
print_all_deps:
	echo Dependencies of $(GUI_DIR)/hopman: $(GUI_DEPS)
	echo Dependencies of $(WATCH_DIR)/watch.a: $(WATCH_DEPS)
	echo Dependencies of $(ANNEX_DIR)/annex.a: $(ANNEX_DEPS)

=== GTK/Makefile ===
# The goal of this makefile is to build the executable hopman
# It uses static libraries in two other subdirectories, plus an icon
# and it also depends on the general header file hopman.h

ICON := ../icon/removable-media-32x32.png
WATCH_DIR := ../watch
ANNEX_DIR := ../annex

# Search path for hopman.h, watch.a, annex.a and their prerequisites:
VPATH := ..:$(WATCH_DIR):$(ANNEX_DIR)

#WATCH_DEPS := $(shell $(MAKE) -s -r -C $(WATCH_DIR) print_deps)
#ANNEX_DEPS := $(shell $(MAKE) -s -r -C $(ANNEX_DIR) print_deps)
WATCH_DEPS := $(WATCH_DIR)/partition.c $(WATCH_DIR)/init_list.c $(WATCH_DIR)/inot.c $(WATCH_DIR)/sigfd.c \
	$(WATCH_DIR)/hotplug_partition.c $(WATCH_DIR)/mountpoints.c $(WATCH_DIR)/devpath.c $(WATCH_DIR)/readwrite.c \
	$(WATCH_DIR)/sysfs.c $(WATCH_DIR)/sysfs.h $(WATCH_DIR)/watch.h hopman.h
ANNEX_DEPS := $(ANNEX_DIR)/config.c $(ANNEX_DIR)/userinfo.c $(ANNEX_DIR)/newpid.c $(ANNEX_DIR)/do_all_config.c $(ANNEX_DIR)/annex.h hopman.h

OBJECTS := set_icon.o hopman.o gui.o
SOURCES := $(patsubst %.o,%.c,$(OBJECTS)) gui.h

.SUFFIXES:

%.o: %.c
	gcc -c $< -I.. -I../watch `pkg-config --cflags gtk+-2.0`

hopman: $(OBJECTS) $(WATCH_DIR)/watch.a $(ANNEX_DIR)/annex.a
	gcc -o $@ $^ `pkg-config --libs gtk+-2.0`

$(OBJECTS): gui.h hopman.h

set_icon.o: set_icon.c gui.h hopman.h $(ICON) 
	gdk-pixbuf-csource --raw --name=icon_32x32 $(ICON) >icon_32x32
	gcc -c $< -I.. `pkg-config --cflags gtk+-2.0`

.SECONDARY: icon_32x32

$(ANNEX_DIR)/annex.a: $(ANNEX_DEPS)
	$(MAKE) -r -C $(ANNEX_DIR) annex.a

$(WATCH_DIR)/watch.a: $(WATCH_DEPS)
	$(MAKE) -r -C $(WATCH_DIR) watch.a

.PHONY: clean cleanall print_objs print_srcs print_deps
.SILENT: print_objs print_srcs print_deps

clean:
	@rm -vf $(wildcard *.o) $(wildcard *~) icon_32x32

cleanall:
	@rm -vf $(wildcard *.o) $(wildcard *~) icon_32x32 hopman

#------- print objects, source-files and dependencies of the executable hopman
print_objs:
	@echo $(OBJECTS)

print_srcs:
	@echo $(SOURCES)

print_deps:
	@echo $(SOURCES) hopman.h $(ICON) annex.a watch.a

=== annex/Makefile ===

VPATH := ..
# VPATH = .. allows GNU make find hopman.h in parent directory

OBJECTS := config.o userinfo.o newpid.o do_all_config.o
SOURCES := $(patsubst %.o,%.c,$(OBJECTS)) annex.h

.SUFFIXES:

%.o: %.c
	gcc -c $< -I..

annex.a: $(OBJECTS)
	ar -rcs $@ $^

.NOTPARALLEL:
# Race condition may happen when making archive file annex.a
# The file is likely to be corrupted if 2 jobs write it in the same time

$(OBJECTS): annex.h hopman.h

#-----------------------------------------------------

.PHONY: clean cleanall print_objs print_srcs print_deps
.SILENT: print_objs print_srcs print_deps

clean:
	@rm -vf $(wildcard *.o) $(wildcard *~)

cleanall:
	@rm -vf $(wildcard *.o) $(wildcard *~) annex.a

print_objs:
	@echo $(OBJECTS)

print_srcs:
	@echo $(SOURCES)

print_deps:
	@echo $(SOURCES) hopman.h

=== doc/Makefile ===
This makefile deals with installing man pages translations

LANGUAGES := fr
MAN_BASE := /usr/share/man

NL ?= $(LANGUAGES)

=== watch/Makefile ===

VPATH := ..
# VPATH = .. allows GNU make find hopman.h in parent directory

OBJECTS := partition.o init_list.o inot.o sigfd.o hotplug_partition.o \
mountpoints.o devpath.o readwrite.o sysfs.o

SOURCES := $(patsubst %.o,%.c,$(OBJECTS)) watch.h

.SUFFIXES:

%.o: %.c
	gcc -c $< -I.. $(CFLAGS)

watch.a: $(OBJECTS)
	ar -rcs $@ $^

.NOTPARALLEL:
# Race condition may happen when making archive file annex.a
# The file is likely to be corrupted if 2 jobs write it in the same time

$(OBJECTS): watch.h hopman.h

#-----------------------------------------------------
.PHONY: clean cleanall print_srcs print_objs print_deps
.SILENT: print_objs print_srcs print_deps

clean:
	@rm -vf $(wildcard *.o) $(wildcard *~)

cleanall:
	@rm -vf $(wildcard *.o) $(wildcard *~) watch.a

print_objs:
	@echo $(OBJECTS)

print_srcs:
	@echo $(SOURCES)

print_deps:
	@echo $(SOURCES) hopman.h

=== debian/changelog ===
hopman (1.14-1+5gnuinos2) unstable; urgency=medium

  * Increase the version of the dependency on usbmount

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 20 Sep 2025 10:52:21 +0200

hopman (1.14-1+5gnuinos1) unstable; urgency=medium

  * Make use of g_spawn_sync() and g_spawn_async() in place of 
    epopen() in the user interaction callbacks for the sake of 
    compatibility with udisksctl
  * New upstream version 1.14

 -- Aitor <aitor_czr@gnuinos.org>  Fri, 19 Sep 2025 19:37:31 +0200

hopman (1.13-1+5gnuinos1) unstable; urgency=medium

  * Add a new variable to partition_new() that indicates where root 
    is mounted. If the partition is a child of this device (e.g, the 
    EFI partition), it'll be skipped even if it doesn't appear in 
    /etc/mtab
  * Fix compiler warnings 
  * New upstream version 1.13

 -- Aitor <aitor_czr@gnuinos.org>  Fri, 05 Sep 2025 00:19:34 +0200

hopman (1.12-1+5gnuinos1) unstable; urgency=medium

  * Add new partition attribute "uuid" and discard those partitions 
    appearing in /etc/fstab. In doing so, we don't verify via sysfs 
    whether the device belongs to a "usb" subsystem anymore. On the
    other hand, we ensure that internal disk's partitions are listed 
    in the case of live sessions.
  * New upstream version 1.12

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 10 Feb 2024 17:01:46 +0100

hopman (1.11-1+5gnuinos1) unstable; urgency=medium

  * GtkStatusIcon integration
  * New upstream version 1.11

 -- Aitor <aitor_czr@gnuinos.org>  Thu, 08 Feb 2024 23:27:48 +0100

hopman (1.10-1+5gnuinos1) unstable; urgency=medium

  * Changed the usbmount script
  * Adapt some partition utilities to the changes aplied to the 
    usbmount script.
  * New upstream version 1.10

 -- Aitor <aitor_czr@gnuinos.org>  Mon, 05 Feb 2024 19:06:12 +0100

hopman (1.9-1+5gnuinos1) unstable; urgency=medium

  * Fixed the problem of the octal-scape-secuence \040 in mountpoints
    making use of getmntent() to parse /proc/mounts
  * New upstream version 1.9

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 31 Jan 2024 21:29:23 +0100

hopman (1.8-1+5gnuinos1) unstable; urgency=medium

  * Minor changes to the commands
  * New upstream version 1.8

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 28 Jan 2024 13:47:37 +0100

hopman (1.7-1+5gnuinos1) unstable; urgency=medium

  * Build for daedalus

 -- Aitor <aitor_czr@gnuinos.org>  Wed, 12 Jul 2023 19:28:34 +0200

hopman (1.7-1) unstable; urgency=medium

  * Fixed "Open with..." not working in /media
  * New upstream version 1.7

 -- Aitor <aitor_czr@gnuinos.org>  Sun, 25 Jun 2023 20:14:22 +0200

hopman (1.6-1) unstable; urgency=medium

  * Fix segmentation fault in 32 bit
  * New upstream version 1.6

 -- Aitor <aitor@gnuinos>  Mon, 19 Jun 2023 23:06:12 +0200

hopman (1.5-1) unstable; urgency=medium

  * Don't keep track of the number of partitions and use g_list_length() in order
    to determine whether or not the partition list is empty
  * Sort partitions alphabetically and add GtkSeparators to the menu
  * Iterate the children of each container in the menu tree when a menu item is 
    going to be removed, and do not use the provision *uiptr[] for the private use 
    of the UI declared within the partinfo_t structure in hopman.h
  * Fix some critical Gtk warnings
  * Add new flags "ShowSize", "keepAbove" to the configuration  
  * New upstream version 1.5

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 17 Jun 2023 00:19:00 +0200

hopman (1.4-1) unstable; urgency=medium

  * Remove hopmanctl in favor of usbmount
  * Conflicts: xfce4-hopman-plugin
  * Depend on higher version of usbmount (>= 0.8-1~)
  * Append more GtkLabels to the menu items including some additional info about the 
    given partition
  * Change the partition size returned by hotplug_partition() from 'int' to 'long int'
  * Change to quilt source format
  * New upstream version 1.4

 -- Aitor <aitor_czr@gnuinos.org>  Sat, 10 Jun 2023 15:43:09 +0200

hopman (1.3) unstable; urgency=medium

  * New upstream version 1.3
  * Depend on usbmount
  * Force creation of disk/by-label before adding it to the watch descriptor wd_label
  * New function partition_set_label_by_blkid()

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Thu, 16 Feb 2023 22:53:26 +0100

hopman (1.2) chimaera; urgency=medium

  * Spawn an asynchronous secondary child process fully detached from parent in case of 
    "Open_in_File_Manager" | "Open_in_Terminal" commands

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Mon, 25 Jul 2022 14:02:40 +0200

hopman (1.1) chimaera; urgency=medium

  * Initial release.

 -- Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>  Sun, 01 May 2022 21:22:39 +0200

=== debian/control ===
Source: hopman
Section: misc
Priority: optional
Origin: Gnuinos
Maintainer: Aitor Cuadrado Zubizarreta <aitor_czr@gnuinos.org>
Uploaders: Didier Kryn <kryn@in2p3.fr>
Build-Depends: debhelper (>= 12), dpkg-dev (>= 1.16.1~), dh-exec, libgtk2.0-dev (>= 2.24.33-2), intltool
Standards-Version: 3.9.5.0
Homepage: https://git.devuan.org/kryn/hopman

Package: hopman
Section: misc
Architecture: linux-any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
  libgtk2.0-0 (>= 2.24.33-2),
  libnotify4 (>= 0.7.9-3),
  usbmount (>= 1.3.4-1~)
Description: Gtk interface which displays removable partitions currently plugged in.
 .
 Hopman is a graphics tool which displays removable partitions currently
 plugged into the computer. It displays also the partition's label if any,
 and the mountpoint, if mounted.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@

override_dh_auto_install:
	gzip -c doc/man/man8/hopman > debian/hopman/usr/share/man/man8/hopman.8.gz
	gzip -c doc/man/man8/hopmanrc > debian/hopman/usr/share/man/man8/hopmanrc.8.gz
	install -m 644 $(CURDIR)/icon/removable-media-32x32.png debian/hopman/usr/share/pixmaps/hopman.png
	install -m 644 $(CURDIR)/LICENSE debian/hopman/usr/share/doc/hopman  
	install -m 644 $(CURDIR)/annex/hopmanrc debian/hopman/etc/default
	install -m 644 $(CURDIR)/hopman.desktop debian/hopman/usr/share/applications

override_dh_strip:
